package com.lzmispt.data.resource.service.collectiontool.impl;

package .tmp;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.lzmispt.core.dao.database.impl.BaseDaoImpl;
import com.lzmispt.core.entity.dto.authorize.UserInfoDTO;
import com.lzmispt.core.entity.dto.listdeletemodel.ListDeleteModelDTO;
import com.lzmispt.core.service.authorize.impl.AuthorizeImpl;
import com.lzmispt.core.service.file.impl.FileServiceImpl;
import com.lzmispt.core.service.listdelete.ListDeleteUtil;
import com.lzmispt.core.service.login.impl.LoginImpl;
import com.lzmispt.data.center.entity.dto.databasestruct.DataSourceDTO;
import com.lzmispt.data.center.entity.dto.log.CommonLogDTO;
import com.lzmispt.data.center.entity.dto.querymodel.DCQueryModelDTO;
import com.lzmispt.data.center.entity.dto.resource.metadata.DataBrowseQueryDTO;
import com.lzmispt.data.center.entity.dto.standard.codetable.MetadataCommonCodeItemQueryDTO;
import com.lzmispt.data.center.entity.enums.BaseSysFieldEnum;
import com.lzmispt.data.center.entity.enums.StatusCodeEnum;
import com.lzmispt.data.center.entity.vo.fieldrelationpage.SystemFieldRelationPageConfigVO;
import com.lzmispt.data.center.entity.vo.resource.datasource.DataSourceVO;
import com.lzmispt.data.center.entity.vo.standard.codetable.MetadataCommonCodeItemVO;
import com.lzmispt.data.center.entity.vo.standard.metadata.ApplyEntityAndDirInfo;
import com.lzmispt.data.center.entity.vo.standard.metadata.MetadataEntityDataItemVO;
import com.lzmispt.data.resource.client.CoreClient;
import com.lzmispt.data.resource.client.DataApplyClient;
import com.lzmispt.data.resource.client.DataStandardClient;
import com.lzmispt.data.resource.client.ResourceClient;
import com.lzmispt.data.resource.dao.collectiontool.ICollectionToolDao;
import com.lzmispt.data.resource.dao.specialdatabase.IResSpecialDatabaseDao;
import com.lzmispt.data.resource.entity.dto.collectiontool.AddExcelTemplateDTO;
import com.lzmispt.data.resource.entity.dto.collectiontool.ExcelTemplateDTO;
import com.lzmispt.data.resource.entity.dto.collectiontool.SaveExcelSheetParamDTO;
import com.lzmispt.data.resource.entity.dto.resanddata.ResAndDataDirectoryDTO;
import com.lzmispt.data.resource.entity.dto.resanddata.ResAndDataEntityDTO;
import com.lzmispt.data.resource.entity.po.collectiontool.ExcelDetailsPO;
import com.lzmispt.data.resource.entity.po.collectiontool.ExcelSheetPO;
import com.lzmispt.data.resource.entity.po.collectiontool.ExcelTemplatePO;
import com.lzmispt.data.resource.entity.po.metadata.MetadataDirectoryPO;
import com.lzmispt.data.resource.entity.po.metadata.MetadataEntityInfoItemPO;
import com.lzmispt.data.resource.entity.po.metadata.MetadataEntityPO;
import com.lzmispt.data.resource.entity.po.specialdatabase.ResDirectoryPO;
import com.lzmispt.data.resource.entity.po.specialdatabase.ResSpecialDatabasePO;
import com.lzmispt.data.resource.entity.vo.collectiontool.ExcelDetailsVO;
import com.lzmispt.data.resource.entity.vo.collectiontool.ExcelSheetVO;
import com.lzmispt.data.resource.entity.vo.collectiontool.ExcelTemplateVO;
import com.lzmispt.data.resource.entity.vo.metadata.MetaEntityRelationsVO;
import com.lzmispt.data.resource.manager.metadata.MetadataManager;
import com.lzmispt.data.resource.service.collectiontool.IExcelCollection;
import com.lzmispt.data.resource.service.collectiontool.IExcelImport;
import com.lzmispt.data.resource.service.collectiontool.impl.ExcelImportContext;
import com.lzmispt.data.resource.service.metadata.IDataBrowse;
import com.lzmispt.data.resource.service.metadata.IInfoItemSync;
import com.lzmispt.data.resource.service.metadata.IResAndDataEntityRelation;
import com.lzmispt.dcbase.ServiceUtil;
import com.lzmispt.dcbase.database.IManage;
import com.lzmispt.dcbase.databasestruct.DataStructProvider;
import com.lzmispt.dcbase.dcconst.DCConst;
import com.lzmispt.dcbase.sysfield.SysFieldHelper;
import com.lzmispt.dcbase.util.HeaderInterceptor;
import com.lzmispt.dcbase.util.TokenUtil;
import com.lzmispt.framework.entity.dto.excel.ExcelFieldConfigDTO;
import com.lzmispt.framework.entity.dto.excel.ExcelSheetConfigDTO;
import com.lzmispt.framework.entity.dto.excel.ExcelWorkbookConfigDTO;
import com.lzmispt.framework.entity.entity.ResultEntity;
import com.lzmispt.framework.entity.enums.ECControllerTypeMode;
import com.lzmispt.framework.exception.ExceptionUtil;
import com.lzmispt.framework.fconst.FrameConst;
import com.lzmispt.framework.utils.ExcelUtil;
import com.lzmispt.framework.utils.RabbitMQUtil;
import com.lzmispt.framework.utils.WorkerId;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.stream.Collectors;
import javax.annotation.Resource;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.cloud.context.config.annotation.RefreshScope;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;
import org.springframework.util.StringUtils;
import org.springframework.web.multipart.MultipartFile;

@Service
@RefreshScope
public class ExcelCollectionImpl implements IExcelCollection, IManage {
  @Autowired
  BaseDaoImpl baseDao;
  
  @Autowired
  AuthorizeImpl authorize;
  
  @Autowired
  DataStandardClient dataStandardClient;
  
  @Autowired
  ResourceClient resourceClient;
  
  @Autowired
  CoreClient coreClient;
  
  @Autowired
  FileServiceImpl fileService;
  
  @Autowired
  LoginImpl loginImpl;
  
  @Autowired
  IResAndDataEntityRelation iResAndDataEntityRelation;
  
  @Autowired
  private IResSpecialDatabaseDao resSpecialDatabaseDao;
  
  @Resource
  DataApplyClient dataApplyClient;
  
  @Value("${data-center.primary-key-mode}")
  private String primaryKeyMode;
  
  @Value("${data-center.data-mode:mysql}")
  private String dbType;
  
  public String getDefaultCode() {
    return "Collection";
  }
  
  public ResultEntity<List<ExcelTemplateVO>> getCollectionTemplates(DCQueryModelDTO queryModelDTO) {
    List<ExcelTemplateVO> result = new ArrayList<>();
    List<ExcelTemplatePO> list = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(queryModelDTO.getPlatCode(), ICollectionToolDao.class)).getCollectionTemplates(queryModelDTO);
    for (int i = 0; i < list.size(); i++) {
      ExcelTemplatePO po = list.get(i);
      ExcelTemplateVO vo = new ExcelTemplateVO();
      BeanUtils.copyProperties(po, vo);
      result.add(vo);
    } 
    return ResultEntity.successMessage(result);
  }
  
  public ResultEntity<String> checkTemplate(Long id, String platCode, String tokenId, Map cache, Boolean isUseCache, Integer dataResourceCategory) {
    List<ExcelSheetPO> excelSheetPOS = new ArrayList<>();
    if (!isUseCache.booleanValue()) {
      ExcelTemplatePO excelTemplatePO = (ExcelTemplatePO)this.baseDao.load(id, ExcelTemplatePO.class);
      dataResourceCategory = excelTemplatePO.getDataCategory();
      if (excelTemplatePO == null)
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_CHECK_TEMPLATE_EXIST.getCode()), StatusCodeEnum.DATA_RESOURCE_EXCEL_CHECK_TEMPLATE_EXIST.getMessage()); 
      excelSheetPOS = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).getExcelSheetsByTempId(id);
    } else {
      excelSheetPOS = (List<ExcelSheetPO>)cache.get("excelSheetPOList");
    } 
    if (!isUseCache.booleanValue()) {
      Map<String, List<Long>> directoryIds = new HashMap<>();
      List<Long> childTableSheetIds = new ArrayList<>();
      for (int i = 0; i < excelSheetPOS.size(); i++) {
        if (DCConst.TRUE.equals(((ExcelSheetPO)excelSheetPOS.get(i)).getIsPrimaryTable())) {
          List<MetaEntityRelationsVO> metadataEntityRelationsPOList = this.iResAndDataEntityRelation.getParentRelationsByEntityId(((ExcelSheetPO)excelSheetPOS.get(i)).getEntityId(), dataResourceCategory, platCode);
          if (metadataEntityRelationsPOList != null && !metadataEntityRelationsPOList.isEmpty()) {
            childTableSheetIds.add(((ExcelSheetPO)excelSheetPOS.get(i)).getSheetId());
          } else if (directoryIds.containsKey(((ExcelSheetPO)excelSheetPOS.get(i)).getPlatCode()) && directoryIds.get(((ExcelSheetPO)excelSheetPOS.get(i)).getPlatCode()) != null) {
            ((List<Long>)directoryIds.get(((ExcelSheetPO)excelSheetPOS.get(i)).getPlatCode())).add(((ExcelSheetPO)excelSheetPOS.get(i)).getDirectoryId());
          } else {
            List<Long> dirIds = new ArrayList<>();
            dirIds.add(((ExcelSheetPO)excelSheetPOS.get(i)).getDirectoryId());
            directoryIds.put(((ExcelSheetPO)excelSheetPOS.get(i)).getPlatCode(), dirIds);
          } 
        } else {
          childTableSheetIds.add(((ExcelSheetPO)excelSheetPOS.get(i)).getSheetId());
        } 
      } 
      if (!CollectionUtils.isEmpty(childTableSheetIds))
        ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).delExcelSheets(childTableSheetIds); 
      if (!directoryIds.isEmpty()) {
        SaveExcelSheetParamDTO saveExcelSheetParamDTO = new SaveExcelSheetParamDTO();
        saveExcelSheetParamDTO.setExcelTemplateId(id);
        saveExcelSheetParamDTO.setDirectoryIds(directoryIds);
        saveExcelSheetParamDTO.setTokenId(tokenId);
        saveExcelSheetParamDTO.setCache(cache);
        saveExcelSheetParamDTO.setIsUseCache(isUseCache);
        saveExcelSheet(saveExcelSheetParamDTO, platCode, dataResourceCategory);
      } 
      excelSheetPOS = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).getExcelSheetsByTempId(id);
    } 
    ResultEntity<String> errorMsg = checkEntityAndField(excelSheetPOS, platCode, tokenId, dataResourceCategory);
    if (!errorMsg.getCode().equals(Integer.valueOf(0)))
      return errorMsg; 
    return ResultEntity.successMessage("ok");
  }
  
  public ResultEntity<String> checkTemplateByDirectoryId(Long directoryId, String platCode, String tokenId, Integer dataResourceCategory) {
    Map cache = getCacheByDirectoryId(directoryId, tokenId, platCode, dataResourceCategory);
    return checkTemplate(directoryId, platCode, tokenId, cache, Boolean.valueOf(true), dataResourceCategory);
  }
  
  public ResultEntity<Boolean> addTemplate(AddExcelTemplateDTO excelTemplateDTO, String platCode, String tokenId) {
    List<ExcelTemplatePO> list = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).getCollectionTemplatesByName(excelTemplateDTO.getTemplateName(), excelTemplateDTO.getDataCategory());
    if (list != null && !list.isEmpty())
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_TEMPLATE_NAME_SAME.getCode()), StatusCodeEnum.DATA_RESOURCE_EXCEL_TEMPLATE_NAME_SAME.getMessage()); 
    ExcelTemplatePO excelTemplatePO = new ExcelTemplatePO();
    BeanUtils.copyProperties(excelTemplateDTO, excelTemplatePO);
    excelTemplatePO.setCreateTime(new Date());
    excelTemplatePO.setIsDelete(DCConst.FALSE);
    excelTemplatePO.setTemplateId((Long)WorkerId.getNextId(Long.class));
    if (excelTemplatePO.getTemplateOrder() == null) {
      Integer order = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).getExcelTemplateMaxOrder(excelTemplateDTO.getDataCategory());
      excelTemplatePO.setTemplateOrder(order);
    } 
    String msg = "新增模板【" + excelTemplatePO.getTemplateName() + "】";
    logSystemInfo(msg, platCode, tokenId);
    return ResultEntity.successMessage(Boolean.valueOf(((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).addEntity(excelTemplatePO)));
  }
  
  public ResultEntity<Boolean> updateTemplate(ExcelTemplateDTO excelTemplateDTO, String platCode, String tokenId) {
    ExcelTemplatePO excelTemplatePO = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).getCollectionTemplateById(excelTemplateDTO.getTemplateId());
    if (excelTemplatePO != null) {
      BeanUtils.copyProperties(excelTemplateDTO, excelTemplatePO);
      excelTemplatePO.setUpdateTime(new Date());
      excelTemplatePO.setUserId(excelTemplatePO.getUserId());
      excelTemplatePO.setOrganizationId(excelTemplatePO.getOrganizationId());
      return ResultEntity.successMessage(Boolean.valueOf(((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).updateEntity(excelTemplatePO)));
    } 
    return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_CHECK_TEMPLATE_EXIST.getCode()), StatusCodeEnum.DATA_RESOURCE_EXCEL_CHECK_TEMPLATE_EXIST.getMessage());
  }
  
  public ResultEntity<Boolean> deleteExcelDetails(ListDeleteModelDTO listDeleteModelDTO, String platCode) {
    ResultEntity whereSqlRet = ListDeleteUtil.getListDeleteWhere(listDeleteModelDTO, this.dbType);
    String whereSql = "";
    if (whereSqlRet.getCode().equals(Integer.valueOf(0)) && whereSqlRet.getObj() != null)
      whereSql = whereSqlRet.getObj().toString(); 
    if (listDeleteModelDTO.isSelectAll()) {
      List<ExcelDetailsPO> details = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).getExcelDetailsByWhere(whereSql);
      if (!details.isEmpty()) {
        List<Long> delIds = new ArrayList<>();
        for (int i = 0; i < details.size(); i++) {
          if (listDeleteModelDTO.getDeselectKeys() == null || listDeleteModelDTO.getDeselectKeys().isEmpty() || !listDeleteModelDTO.getDeselectKeys().contains(((ExcelDetailsPO)details.get(i)).getRecordId()))
            delIds.add(((ExcelDetailsPO)details.get(i)).getRecordId()); 
        } 
        ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).delExcelDetails(delIds);
      } 
    } else if (listDeleteModelDTO.getSelectKeys() != null && !listDeleteModelDTO.getSelectKeys().isEmpty()) {
      ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).delExcelDetails(listDeleteModelDTO.getSelectKeys());
    } 
    return ResultEntity.successMessage(Boolean.valueOf(true));
  }
  
  public ResultEntity<Boolean> saveExcelSheets(SaveExcelSheetParamDTO saveExcelSheetParamDTO, String platCode, Integer dataResourceCategory) {
    if (!saveExcelSheetParamDTO.getIsUseCache().booleanValue())
      ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).delExcelSheetsByTemplateId(saveExcelSheetParamDTO.getExcelTemplateId()); 
    UserInfoDTO userInfoDTO = TokenUtil.getUserInfoByTokenId(saveExcelSheetParamDTO.getTokenId());
    saveExcelSheetParamDTO.setUserId(userInfoDTO.getUserId());
    saveExcelSheetParamDTO.setOrganizationId(userInfoDTO.getOrganizationId());
    saveExcelSheet(saveExcelSheetParamDTO, platCode, dataResourceCategory);
    ExcelTemplatePO excelTemplatePO = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).getCollectionTemplateById(saveExcelSheetParamDTO.getExcelTemplateId());
    if (excelTemplatePO != null) {
      excelTemplatePO.setDataCategory(dataResourceCategory);
      ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).updateEntity(excelTemplatePO);
    } 
    return ResultEntity.successMessage(Boolean.valueOf(true));
  }
  
  public ResultEntity<List<ExcelDetailsVO>> getExcelDetailList(DCQueryModelDTO queryModelDTO) {
    List<ExcelDetailsVO> result = new ArrayList<>();
    List<ExcelDetailsPO> list = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(queryModelDTO.getPlatCode(), ICollectionToolDao.class)).getExcelDetails(queryModelDTO);
    for (int i = 0; i < list.size(); i++) {
      ExcelDetailsPO po = list.get(i);
      ExcelDetailsVO vo = new ExcelDetailsVO();
      BeanUtils.copyProperties(po, vo);
      result.add(vo);
    } 
    return ResultEntity.successMessage(result);
  }
  
  public ResultEntity<List<ExcelSheetVO>> getExcelSheetList(DCQueryModelDTO dcQueryModelDTO) {
    List<ExcelSheetVO> result = new ArrayList<>();
    List<ExcelSheetPO> list = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(dcQueryModelDTO.getPlatCode(), ICollectionToolDao.class)).selectExcelSheets(dcQueryModelDTO);
    for (int i = 0; i < list.size(); i++) {
      ExcelSheetPO po = list.get(i);
      ExcelSheetVO vo = new ExcelSheetVO();
      BeanUtils.copyProperties(po, vo);
      result.add(vo);
    } 
    return ResultEntity.successMessage(result);
  }
  
  public ResultEntity<Map> deleteExcelTemplate(ListDeleteModelDTO listDeleteModelDTO, String platCode, String tokenId) {
    ResultEntity whereSqlRet = ListDeleteUtil.getListDeleteWhere(listDeleteModelDTO, this.dbType);
    String whereSql = "";
    if (whereSqlRet.getCode().equals(Integer.valueOf(0)) && whereSqlRet.getObj() != null)
      whereSql = whereSqlRet.getObj().toString(); 
    Map<Object, Object> resultMap = new HashMap<>();
    List<Long> successList = new ArrayList<>();
    List<Long> failedList = new ArrayList<>();
    if (listDeleteModelDTO.isSelectAll()) {
      List<ExcelTemplatePO> templatePOS = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).getCollectionTemplatesByWhere(whereSql);
      if (!templatePOS.isEmpty())
        for (int i = 0; i < templatePOS.size(); i++) {
          if (listDeleteModelDTO.getDeselectKeys() == null || listDeleteModelDTO.getDeselectKeys().isEmpty() || !listDeleteModelDTO.getDeselectKeys().contains(((ExcelTemplatePO)templatePOS.get(i)).getTemplateId())) {
            deleteInfoByExcelTemplateId(templatePOS.get(i), platCode, tokenId);
            if (templatePOS.get(i) != null)
              successList.add(((ExcelTemplatePO)templatePOS.get(i)).getTemplateId()); 
          } 
        }  
    } else if (listDeleteModelDTO.getSelectKeys() != null && !listDeleteModelDTO.getSelectKeys().isEmpty()) {
      for (int i = 0; i < listDeleteModelDTO.getSelectKeys().size(); i++) {
        ExcelTemplatePO excelTemplatePO = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).getCollectionTemplateById(listDeleteModelDTO.getSelectKeys().get(i));
        deleteInfoByExcelTemplateId(excelTemplatePO, platCode, tokenId);
        if (excelTemplatePO != null)
          successList.add(excelTemplatePO.getTemplateId()); 
      } 
    } 
    successList = (List<Long>)successList.stream().distinct().collect(Collectors.toList());
    failedList = (List<Long>)failedList.stream().distinct().collect(Collectors.toList());
    resultMap.put("successList", successList);
    resultMap.put("failedList", failedList);
    String delMsg = String.format(StatusCodeEnum.DATA_RESOURCE_DELETE_MSG.getMessage(), new Object[] { Integer.valueOf(successList.size()), Integer.valueOf(failedList.size()) });
    if (failedList.isEmpty())
      return ResultEntity.successMessage(delMsg, resultMap); 
    return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_DELETE_MSG.getCode()), delMsg, resultMap);
  }
  
  public ResultEntity<Boolean> deleteExcelSheets(List<Long> ids, String platCode) {
    return ResultEntity.successMessage(Boolean.valueOf(((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).delExcelSheets(ids)));
  }
  
  public ResultEntity<String> downLoadExcelTemplate(HttpServletResponse response, Long templateId, String platCode, String tokenId, Map cache, Boolean isUseCache, Integer dataResourceCategory) {
    ExcelTemplatePO excelTemplatePO = null;
    if (!isUseCache.booleanValue()) {
      excelTemplatePO = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).getCollectionTemplateById(templateId);
      if (excelTemplatePO != null)
        dataResourceCategory = excelTemplatePO.getDataCategory(); 
    } 
    ResultEntity<String> checkTemplateRet = checkTemplate(templateId, platCode, tokenId, cache, isUseCache, dataResourceCategory);
    if (!checkTemplateRet.getCode().equals(Integer.valueOf(0)))
      return checkTemplateRet; 
    ExcelWorkbookConfigDTO excelWorkbook = new ExcelWorkbookConfigDTO();
    List<ExcelSheetPO> excelSheetPOList = getExcelSheetPOListByDirId(templateId, platCode, tokenId, cache, isUseCache, dataResourceCategory, excelTemplatePO, excelWorkbook);
    if (excelSheetPOList != null && !excelSheetPOList.isEmpty())
      try {
        XSSFWorkbook xSSFWorkbook = getExcelTemplate(templateId, platCode, tokenId, excelTemplatePO, excelSheetPOList, dataResourceCategory);
        if (response != null) {
          response.setContentType("application/vnd.ms-excel;charset=utf-8");
          response.setHeader("Content-Disposition", "attachment;filename=\"" + new String((excelWorkbook.getWorkbookName() + ".xlsx").getBytes("gb2312"), "ISO8859-1"));
          ServletOutputStream servletOutputStream = response.getOutputStream();
          xSSFWorkbook.write((OutputStream)servletOutputStream);
          servletOutputStream.close();
          return null;
        } 
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_DOWN_LOAD_FAILED.getCode()), StatusCodeEnum.DATA_RESOURCE_EXCEL_DOWN_LOAD_FAILED.getMessage());
      } catch (Exception e) {
        logErrorInfo(ExceptionUtil.getStackTraceMsg(e), "下载excel模板失败", getDefaultCode(), tokenId);
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_DOWN_LOAD_FAILED.getCode()), StatusCodeEnum.DATA_RESOURCE_EXCEL_DOWN_LOAD_FAILED.getMessage());
      }  
    return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_SET_TEMPLATE_WARN.getCode()), StatusCodeEnum.DATA_RESOURCE_EXCEL_SET_TEMPLATE_WARN.getMessage());
  }
  
  private List<ExcelSheetPO> getExcelSheetPOListByDirId(Long templateId, String platCode, String tokenId, Map cache, Boolean isUseCache, Integer dataResourceCategory, ExcelTemplatePO excelTemplatePO, ExcelWorkbookConfigDTO excelWorkbook) {
    List<ExcelSheetPO> excelSheetPOList = new LinkedList<>();
    if (!isUseCache.booleanValue()) {
      excelTemplatePO = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).getCollectionTemplateById(templateId);
      excelSheetPOList = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).getExcelSheetsByTempId(templateId);
      excelWorkbook.setWorkbookName(excelTemplatePO.getTemplateName());
    } else {
      ResAndDataDirectoryDTO resAndDataDirectoryDTO = MetadataManager.selectDirectoryByDirectoryId(templateId, platCode, dataResourceCategory);
      ResAndDataEntityDTO resAndDataEntityDTO = MetadataManager.selectIsMasterMetadataEntityByDirectoryId(resAndDataDirectoryDTO.getDirectoryId(), dataResourceCategory, platCode, tokenId);
      excelWorkbook.setWorkbookName(resAndDataEntityDTO.getEntityName());
      excelSheetPOList = (List<ExcelSheetPO>)cache.get("excelSheetPOList");
    } 
    return excelSheetPOList;
  }
  
  public ResultEntity<String> downLoadExcelTemplateByDirectoryId(HttpServletResponse response, Long directoryId, String platCode, String tokenId, Integer dataResourceCategory) {
    Map cache = getCacheByDirectoryId(directoryId, tokenId, platCode, dataResourceCategory);
    ResultEntity<String> downLoadExcelTemplateResultEntity = downLoadExcelTemplate(response, directoryId, platCode, tokenId, cache, Boolean.valueOf(true), dataResourceCategory);
    if (downLoadExcelTemplateResultEntity != null && !downLoadExcelTemplateResultEntity.getCode().equals(Integer.valueOf(0)))
      return downLoadExcelTemplateResultEntity; 
    cache = null;
    return null;
  }
  
  public ResultEntity importExcelByDirectoryId(HttpServletResponse response, MultipartFile file, Long directoryId, String platCode, String tokenId, Integer dataResourceCategory) {
    Map cache = getCacheByDirectoryId(directoryId, tokenId, platCode, dataResourceCategory);
    List<ExcelSheetPO> cacheExcelSheetPoList = (List<ExcelSheetPO>)cache.get("excelSheetPOList");
    ResultEntity importExcelResult = ((IExcelImport)ServiceUtil.getExcelImportImplManager(platCode, IExcelImport.class)).importExcel(response, file, directoryId, platCode, tokenId, Boolean.valueOf(true), cacheExcelSheetPoList, dataResourceCategory);
    if (importExcelResult.getCode().intValue() != 0)
      return importExcelResult; 
    ExcelDetailsVO excelDetailsVO = (ExcelDetailsVO)importExcelResult.getObj();
    Map<String, Object> result = new HashMap<>();
    result.put("dataCount", excelDetailsVO.getTotalNumber());
    result.put("needImportCount", Integer.valueOf(excelDetailsVO.getNumberOfSuccessful().intValue() + excelDetailsVO.getNumberOfFailures().intValue()));
    result.put("errorRowCount", excelDetailsVO.getNumberOfFailures());
    List<String> errorInfo = new ArrayList<>();
    JSONArray details = JSONArray.parseArray(excelDetailsVO.getDetails());
    for (Object json : details) {
      Map jsonMap = (Map)json;
      if (jsonMap.containsKey("sheetName") && jsonMap.containsKey("operationMsg")) {
        List<String> msgList = (List<String>)jsonMap.get("operationMsg");
        for (String msg : msgList)
          errorInfo.add(msg); 
      } 
    } 
    result.put("errorInfo", errorInfo);
    result.put("isSuccess", Boolean.valueOf(true));
    if (excelDetailsVO.getNumberOfFailures().intValue() > 0 || !errorInfo.isEmpty())
      result.put("isSuccess", Boolean.valueOf(false)); 
    return ResultEntity.successMessage(result);
  }
  
  private Map getCacheByDirectoryId(Long directoryId, String tokenId, String platCode, Integer dataResourceCategory) {
    Map<Object, Object> cache = new HashMap<>();
    SaveExcelSheetParamDTO saveExcelSheetParamDTO = new SaveExcelSheetParamDTO();
    saveExcelSheetParamDTO.setTokenId(tokenId);
    Map<String, List<Long>> directoryIds = new HashMap<>();
    List<Long> dirIds = new ArrayList<>();
    dirIds.add(directoryId);
    directoryIds.put(platCode, dirIds);
    saveExcelSheetParamDTO.setDirectoryIds(directoryIds);
    saveExcelSheetParamDTO.setExcelTemplateId(directoryId);
    saveExcelSheetParamDTO.setCache(cache);
    saveExcelSheetParamDTO.setIsUseCache(Boolean.valueOf(true));
    saveExcelSheets(saveExcelSheetParamDTO, platCode, dataResourceCategory);
    return cache;
  }
  
  public ResultEntity<String> downLoadDetails(HttpServletResponse response, Long recordId, String platCode, String tokenId) {
    String result = null;
    ExcelDetailsPO detailsPO = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).getExcelDetailsById(recordId);
    if (detailsPO != null)
      result = handleImportExcelRecordTxtLog(response, detailsPO); 
    if (StringUtils.hasText(result))
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_DOWN_LOAD_LOG_FAILED.getCode()), result); 
    return ResultEntity.successMessage(result);
  }
  
  public XSSFWorkbook getExcelTemplate(Long templateId, String platCode, String tokenId, ExcelTemplatePO template, List<ExcelSheetPO> excelSheetPOList, Integer isRes) throws Exception {
    XSSFWorkbook workbook = null;
    ExcelWorkbookConfigDTO excelWorkbook = new ExcelWorkbookConfigDTO();
    if (template != null) {
      excelWorkbook.setWorkbookName(template.getTemplateName());
    } else {
      ResAndDataDirectoryDTO resAndDataDirectoryDTO = MetadataManager.selectDirectoryByDirectoryId(templateId, platCode, isRes, tokenId);
      ResAndDataEntityDTO resAndDataEntityDTO = MetadataManager.selectIsMasterMetadataEntityByDirectoryId(resAndDataDirectoryDTO.getDirectoryId(), isRes, platCode, tokenId);
      excelWorkbook.setWorkbookName(resAndDataEntityDTO.getEntityName());
    } 
    if (excelSheetPOList != null && !excelSheetPOList.isEmpty()) {
      List<ExcelSheetConfigDTO> excelSheetList = getExcelSheetConfig(excelSheetPOList, tokenId, platCode, isRes, null);
      excelWorkbook.setSheets(excelSheetList);
      workbook = ExcelUtil.createExcel(excelWorkbook);
    } 
    return workbook;
  }
  
  public List<ExcelSheetConfigDTO> getExcelSheetConfig(List<ExcelSheetPO> excelSheetPOList, String tokenId, String platCode, Integer isRes, ExcelImportContext excelImportContext) {
    return getExcelSheetConfig(excelSheetPOList, tokenId, platCode, isRes, excelImportContext, Boolean.valueOf(false));
  }
  
  public List<ExcelSheetConfigDTO> getExcelSheetConfig(List<ExcelSheetPO> excelSheetPOList, String tokenId, String platCode, Integer isRes, boolean isWithSysField) {
    return getExcelSheetConfig(excelSheetPOList, tokenId, platCode, isRes, null, Boolean.valueOf(isWithSysField));
  }
  
  private List<ExcelSheetConfigDTO> getExcelSheetConfig(List<ExcelSheetPO> excelSheetPOList, String tokenId, String platCode, Integer isRes, ExcelImportContext excelImportContext, Boolean isWithSysField) {
    List<ExcelSheetConfigDTO> excelSheetList = new ArrayList<>();
    List<String> names = new ArrayList<>();
    for (int i = 0; i < excelSheetPOList.size(); i++) {
      ResAndDataEntityDTO resAndDataEntityDTO;
      ExcelSheetPO po = excelSheetPOList.get(i);
      ExcelSheetConfigDTO sheet = new ExcelSheetConfigDTO();
      MetadataEntityPO metadataEntity = null;
      if (excelImportContext != null) {
        metadataEntity = excelImportContext.selectEntityByEntityId(po.getEntityId(), isRes, po.getPlatCode(), tokenId);
      } else {
        resAndDataEntityDTO = MetadataManager.selectEntityByEntityId(po.getEntityId(), isRes, po.getPlatCode(), tokenId);
      } 
      if (!names.contains(resAndDataEntityDTO.getEntityName())) {
        names.add(resAndDataEntityDTO.getEntityName());
        sheet.setSheetName(resAndDataEntityDTO.getEntityName());
      } else {
        ApplyEntityAndDirInfo entityAndDirInfo;
        switch (po.getPlatCode()) {
          case "Collection":
            sheet.setSheetNamePrefix("(采集库)");
            sheet.setSheetName(sheet.getSheetNamePrefix() + resAndDataEntityDTO.getEntityName());
            break;
          case "Manage":
            sheet.setSheetNamePrefix("(管理库)");
            sheet.setSheetName(sheet.getSheetNamePrefix() + resAndDataEntityDTO.getEntityName());
            break;
          case "Apply":
            if (DCConst.DataResourceCategory.RES.equals(isRes)) {
              ResDirectoryPO resDirectoryPO = this.resSpecialDatabaseDao.selectResDirectoryById(resAndDataEntityDTO.getDirectoryId().toString());
              ResSpecialDatabasePO specialdatabasePO = this.resSpecialDatabaseDao.selectByPrimaryKey(resDirectoryPO.getSpecialDatabaseId());
              sheet.setSheetNamePrefix("(" + specialdatabasePO.getSpecialDatabaseName() + "专题库)");
              sheet.setSheetName(sheet.getSheetNamePrefix() + resAndDataEntityDTO.getEntityName());
              break;
            } 
            entityAndDirInfo = (ApplyEntityAndDirInfo)this.dataApplyClient.getEntityDirectoryInfo(resAndDataEntityDTO.getEntityId(), tokenId).getObj();
            if (entityAndDirInfo != null && StringUtils.hasText(entityAndDirInfo.getSpecialDatabaseName())) {
              sheet.setSheetNamePrefix("(" + entityAndDirInfo.getSpecialDatabaseName() + "专题库)");
              sheet.setSheetName(sheet.getSheetNamePrefix() + resAndDataEntityDTO.getEntityName());
            } 
            break;
        } 
      } 
      List<ExcelFieldConfigDTO> fields = getExcelCellsByEntityId(po.getEntityId(), po.getPlatCode(), tokenId, isRes, isWithSysField);
      sheet.setExcelFields(fields);
      excelSheetList.add(sheet);
    } 
    return excelSheetList;
  }
  
  public ResultEntity<Integer> getExcelTemplateMaxOrder(Integer dataCategory) {
    return ResultEntity.successMessage(((ICollectionToolDao)ServiceUtil.getCollectionToolDao(getDefaultCode(), ICollectionToolDao.class)).getExcelTemplateMaxOrder(dataCategory));
  }
  
  public ResultEntity<Boolean> isSameTemplateName(String name, Long templateId, String platCode, String tokenId) {
    ExcelTemplatePO sameName = null;
    ExcelTemplatePO excelTemplate = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).getCollectionTemplateById(templateId);
    List<ExcelTemplatePO> list = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).getCollectionTemplatesByName(name, excelTemplate.getDataCategory());
    if (templateId != null && list != null && !list.isEmpty()) {
      for (int i = 0; i < list.size(); i++) {
        if (!((ExcelTemplatePO)list.get(i)).getTemplateId().equals(templateId)) {
          sameName = list.get(i);
          break;
        } 
      } 
    } else if (list != null && !list.isEmpty()) {
      sameName = list.get(0);
    } 
    return ResultEntity.successMessage(Boolean.valueOf((sameName != null)));
  }
  
  public ResultEntity<Boolean> checkDataSourceApplyExcelSheets(Long dataSourceId) {
    return ResultEntity.successMessage(Boolean.valueOf((((ICollectionToolDao)ServiceUtil.getCollectionToolDao("Collection", ICollectionToolDao.class)).getExcelSheetsByDatasourceId(dataSourceId) != null && (
          (ICollectionToolDao)ServiceUtil.getCollectionToolDao("Collection", ICollectionToolDao.class)).getExcelSheetsByDatasourceId(dataSourceId).size() > 0)));
  }
  
  public List<ExcelTemplateVO> getExcelTemplatesByEntityId(Long entityId, String platCode) {
    ICollectionToolDao collectionToolDao = (ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class);
    List<Long> templateIds = collectionToolDao.getTemplateIdsByEntityId(entityId);
    if (CollectionUtils.isEmpty(templateIds))
      return new ArrayList<>(); 
    List<ExcelTemplatePO> excelTemplates = collectionToolDao.getExcelTemplatesByIds(templateIds);
    List<ExcelTemplateVO> result = new ArrayList<>(excelTemplates.size());
    for (ExcelTemplatePO excelTemplate : excelTemplates) {
      ExcelTemplateVO vo = new ExcelTemplateVO();
      BeanUtils.copyProperties(excelTemplate, vo);
      result.add(vo);
    } 
    return result;
  }
  
  public ResultEntity<String> exportToExcelByDirId(DataBrowseQueryDTO dataBrowseQueryDTO, HttpServletResponse response, Long dirId, String platCode, String tokenId, Map cache, Integer dataResourceCategory) {
    cache = getCacheByDirectoryId(dirId, tokenId, platCode, dataResourceCategory);
    checkTemplate(dirId, platCode, tokenId, cache, Boolean.valueOf(true), dataResourceCategory);
    ExcelTemplatePO excelTemplatePO = null;
    ExcelWorkbookConfigDTO excelWorkbook = new ExcelWorkbookConfigDTO();
    List<ExcelSheetPO> excelSheetPOS = getExcelSheetPOListByDirId(dirId, platCode, tokenId, cache, Boolean.valueOf(true), dataResourceCategory, excelTemplatePO, excelWorkbook);
    if (excelSheetPOS != null && !excelSheetPOS.isEmpty())
      try {
        List<ExcelSheetPO> excelSheetPOList = new ArrayList<>();
        excelSheetPOList.add(excelSheetPOS.get(0));
        XSSFWorkbook workbook = null;
        ResAndDataDirectoryDTO resAndDataDirectoryDTO = MetadataManager.selectDirectoryByDirectoryId(dirId, platCode, dataResourceCategory, tokenId);
        ResAndDataEntityDTO resAndDataEntityDTO = MetadataManager.selectIsMasterMetadataEntityByDirectoryId(resAndDataDirectoryDTO.getDirectoryId(), dataResourceCategory, platCode, tokenId);
        excelWorkbook.setWorkbookName(resAndDataEntityDTO.getEntityName());
        if (excelSheetPOList != null && !excelSheetPOList.isEmpty()) {
          List<ExcelSheetConfigDTO> excelSheetList = getExcelSheetConfig(excelSheetPOList, tokenId, platCode, dataResourceCategory, true);
          ResultEntity<String> getDataRet = ((IDataBrowse)ServiceUtil.getDataBrowseManager(platCode, IDataBrowse.class)).getDataBrowseByDirectoryId(dataBrowseQueryDTO, false, tokenId, dataResourceCategory, platCode, Boolean.valueOf(true));
          if (!getDataRet.getCode().equals(Integer.valueOf(0)))
            return getDataRet; 
          Map<String, Object> dataRet = (Map<String, Object>)getDataRet.getObj();
          if (dataRet.get("dataList") != null) {
            List<Map<String, Object>> dataList = (List<Map<String, Object>>)dataRet.get("dataList");
            handleDataFiledName(platCode, tokenId, dataResourceCategory, (MetadataEntityPO)resAndDataEntityDTO, dataList, dataBrowseQueryDTO.getListSource());
            ((ExcelSheetConfigDTO)excelSheetList.get(0)).setData(dataList);
          } 
          excelWorkbook.setSheets(excelSheetList);
          workbook = ExcelUtil.createExcel(excelWorkbook);
        } 
        if (response != null) {
          response.setContentType("application/vnd.ms-excel;charset=utf-8");
          response.setHeader("Content-Disposition", "attachment;filename=\"" + new String((resAndDataEntityDTO.getEntityName() + ".xlsx").getBytes("gb2312"), "ISO8859-1"));
          ServletOutputStream servletOutputStream = response.getOutputStream();
          workbook.write((OutputStream)servletOutputStream);
          servletOutputStream.close();
          return null;
        } 
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_DOWN_LOAD_FAILED.getCode()), StatusCodeEnum.DATA_RESOURCE_EXCEL_DOWN_LOAD_FAILED.getMessage());
      } catch (Exception e) {
        logErrorInfo(ExceptionUtil.getStackTraceMsg(e), "下载excel模板失败", getDefaultCode(), tokenId);
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_DOWN_LOAD_FAILED.getCode()), StatusCodeEnum.DATA_RESOURCE_EXCEL_DOWN_LOAD_FAILED.getMessage());
      }  
    return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_SET_TEMPLATE_WARN.getCode()), StatusCodeEnum.DATA_RESOURCE_EXCEL_SET_TEMPLATE_WARN.getMessage());
  }
  
  private void handleDataFiledName(String platCode, String tokenId, Integer dataResourceCategory, MetadataEntityPO metadataEntity, List<Map<String, Object>> dataList, Integer sourceList) {
    if (!CollectionUtils.isEmpty(dataList)) {
      List<MetadataEntityInfoItemPO> metadataEntityInfoItemPOList = MetadataManager.getEntityInfoItemsByEntityId(metadataEntity.getEntityId(), dataResourceCategory, platCode, tokenId);
      if (!CollectionUtils.isEmpty(metadataEntityInfoItemPOList)) {
        List<SystemFieldRelationPageConfigVO> systemFieldRelationPageConfigVOS = null;
        if (sourceList != null) {
          List<Integer> types = new ArrayList<>();
          types.add(sourceList);
          systemFieldRelationPageConfigVOS = (List<SystemFieldRelationPageConfigVO>)((Map)this.dataStandardClient.getFieldRelationPageConfig(types, platCode, tokenId).getObj()).get(sourceList);
        } 
        for (Map<String, Object> row : dataList) {
          for (MetadataEntityInfoItemPO infoItem : metadataEntityInfoItemPOList) {
            if (((IInfoItemSync)ServiceUtil.getInfoItemSyncManager(getDefaultCode(), IInfoItemSync.class)).isSystemField(infoItem.getDataItemName()).booleanValue()) {
              String systemFieldName = (String)SysFieldHelper.getSysFieldCnNameMap().get(infoItem.getDataItemName());
              if (!CollectionUtils.isEmpty(systemFieldRelationPageConfigVOS)) {
                SystemFieldRelationPageConfigVO fieldRelationPageConfigVO = systemFieldRelationPageConfigVOS.stream().filter(f -> f.getFieldName().equalsIgnoreCase(infoItem.getDataItemName())).findFirst().orElse(null);
                if (fieldRelationPageConfigVO != null) {
                  if (DCConst.FALSE.equals(fieldRelationPageConfigVO.getIsShow())) {
                    row.remove(infoItem.getDataItemName());
                    continue;
                  } 
                  systemFieldName = StringUtils.isEmpty(fieldRelationPageConfigVO.getFieldNameAlias()) ? fieldRelationPageConfigVO.getFieldName() : fieldRelationPageConfigVO.getFieldNameAlias();
                } 
              } 
              row.put(systemFieldName, row.get(infoItem.getDataItemName()));
            } else {
              row.put(infoItem.getInfoItemName(), row.get(infoItem.getDataItemName()));
            } 
            if (!infoItem.getInfoItemName().equals(infoItem.getDataItemName()))
              row.remove(infoItem.getDataItemName()); 
          } 
        } 
      } 
    } 
  }
  
  private void saveExcelSheet(SaveExcelSheetParamDTO saveExcelSheetParamDTO, String platCode, Integer dataResourceCategory) {
    Map cache = saveExcelSheetParamDTO.getCache();
    Boolean isUseCache = saveExcelSheetParamDTO.getIsUseCache();
    Map<String, List<Long>> directoryIds = saveExcelSheetParamDTO.getDirectoryIds();
    if (!directoryIds.isEmpty()) {
      AtomicInteger order = new AtomicInteger(0);
      for (String dirPlatCode : directoryIds.keySet()) {
        for (int i = 0; i < ((List)directoryIds.get(dirPlatCode)).size(); i++) {
          MetadataEntityPO entity = new MetadataEntityPO();
          ResAndDataEntityDTO resAndDataEntityDTO = MetadataManager.selectIsMasterMetadataEntityByDirectoryId(((List<Long>)directoryIds.get(dirPlatCode)).get(i), dataResourceCategory, dirPlatCode, saveExcelSheetParamDTO.getTokenId());
          BeanUtils.copyProperties(resAndDataEntityDTO, entity);
          if (entity != null)
            setExcelSheet(entity, order, saveExcelSheetParamDTO.getExcelTemplateId(), platCode, saveExcelSheetParamDTO.getUserId(), saveExcelSheetParamDTO.getOrganizationId(), DCConst.TRUE.intValue(), cache, isUseCache, dataResourceCategory, dirPlatCode); 
        } 
      } 
    } 
  }
  
  private void setExcelSheet(MetadataEntityPO metadataEntityPO, AtomicInteger order, Long templateId, String platCode, Long userId, Long organizationId, int isPrimaryTable, Map<String, List<ExcelSheetPO>> cache, Boolean isUseCache, Integer dataResourceCategory, String dirPlatCode) {
    order.set(order.incrementAndGet());
    if (metadataEntityPO != null) {
      List<ExcelSheetPO> excelSheetPOList = new ArrayList<>();
      if (!isUseCache.booleanValue()) {
        excelSheetPOList = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).getExcelSheetsByTempIdAndEntityId(templateId, metadataEntityPO.getEntityId());
        if (excelSheetPOList == null || excelSheetPOList.isEmpty())
          boolean bool = createExcelSheet(metadataEntityPO, Integer.valueOf(order.get()), templateId, dirPlatCode, userId, organizationId, isPrimaryTable, excelSheetPOList, isUseCache); 
      } else {
        if (cache.containsKey("excelSheetPOList"))
          excelSheetPOList = (List<ExcelSheetPO>)cache.get("excelSheetPOList"); 
        createExcelSheet(metadataEntityPO, Integer.valueOf(order.get()), templateId, dirPlatCode, userId, organizationId, isPrimaryTable, excelSheetPOList, isUseCache);
        cache.put("excelSheetPOList", excelSheetPOList);
      } 
      List<MetaEntityRelationsVO> metadataEntityRelationsPOList = this.iResAndDataEntityRelation.getChildRelationsByEntityId(metadataEntityPO.getEntityId(), dataResourceCategory, dirPlatCode);
      if (metadataEntityRelationsPOList != null && !metadataEntityRelationsPOList.isEmpty())
        for (int j = 0; j < metadataEntityRelationsPOList.size(); j++) {
          Long childEntityId = ((MetaEntityRelationsVO)metadataEntityRelationsPOList.get(j)).getFkEntityId();
          MetadataEntityPO childEntity = new MetadataEntityPO();
          ResAndDataEntityDTO resAndDataEntityDTO = MetadataManager.selectEntityByEntityId(childEntityId, dataResourceCategory, dirPlatCode, String.valueOf(WorkerId.getNextId(Long.class)));
          BeanUtils.copyProperties(resAndDataEntityDTO, childEntity);
          setExcelSheet(childEntity, order, templateId, platCode, userId, organizationId, DCConst.FALSE.intValue(), cache, isUseCache, dataResourceCategory, dirPlatCode);
        }  
    } 
  }
  
  private boolean createExcelSheet(MetadataEntityPO metadataEntityPO, Integer order, Long templateId, String platCode, Long userId, Long organizationId, int isPrimaryTable, List<ExcelSheetPO> excelSheetPOList, Boolean isUseCache) {
    ExcelSheetPO excelSheetPO = new ExcelSheetPO();
    excelSheetPO.setCreateTime(new Date());
    excelSheetPO.setDatasourceId(metadataEntityPO.getDataSourceId());
    excelSheetPO.setDirectoryId(metadataEntityPO.getDirectoryId());
    excelSheetPO.setEntityId(metadataEntityPO.getEntityId());
    excelSheetPO.setEntityTableName(metadataEntityPO.getEntityTableName());
    excelSheetPO.setIsDelete(Integer.valueOf(0));
    excelSheetPO.setIsPrimaryTable(Integer.valueOf(isPrimaryTable));
    excelSheetPO.setOrganizationId(organizationId);
    excelSheetPO.setUserId(userId);
    excelSheetPO.setSheetOrder(order);
    excelSheetPO.setSheetId((Long)WorkerId.getNextId(Long.class));
    excelSheetPO.setUpdateTime(new Date());
    excelSheetPO.setTemplateId(templateId);
    excelSheetPO.setPlatCode(platCode);
    if (isUseCache.booleanValue()) {
      if (((List)excelSheetPOList.stream()
        .filter(s -> s.getEntityId().equals(metadataEntityPO.getEntityId()))
        .collect(Collectors.toList())).size() == 0)
        excelSheetPOList.add(excelSheetPO); 
    } else {
      boolean bool = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(getDefaultCode(), ICollectionToolDao.class)).addEntity(excelSheetPO);
    } 
    return true;
  }
  
  private String handleImportExcelRecordTxtLog(HttpServletResponse response, ExcelDetailsPO details) {
    try {
      if (response != null) {
        JSONArray detailArr = JSON.parseArray(details.getDetails());
        StringBuilder msg = new StringBuilder();
        for (int i = 0; i < detailArr.size(); i++) {
          JSONObject json = detailArr.getJSONObject(i);
          List<String> operationMsg = (List<String>)json.get("operationMsg");
          for (int j = 0; j < operationMsg.size(); j++)
            msg.append(operationMsg.get(j)); 
        } 
        byte[] result = msg.toString().getBytes();
        response.setContentType("application/vnd.ms-excel;charset=utf-8");
        response.setHeader("Content-Disposition", "attachment;filename=\"" + new String((details.getRecordId() + ".txt").getBytes("gb2312"), "ISO8859-1"));
        ServletOutputStream servletOutputStream = response.getOutputStream();
        servletOutputStream.write(result);
        servletOutputStream.flush();
        servletOutputStream.close();
        return null;
      } 
      return null;
    } catch (Exception e) {
      return "下载日志信息失败";
    } 
  }
  
  private List<ExcelFieldConfigDTO> getExcelCellsByEntityId(Long entityId, String platCode, String tokenId, Integer isRes, Boolean isWithSysField) {
    int endRowIndex = 10000;
    List<ExcelFieldConfigDTO> excelCellList = new ArrayList<>();
    List<MetadataEntityInfoItemPO> infoItemPOList = MetadataManager.getEntityInfoItemsByEntityId(entityId, isRes, platCode, tokenId);
    if (isWithSysField.booleanValue()) {
      List<MetadataEntityInfoItemPO> systemFields = (List<MetadataEntityInfoItemPO>)infoItemPOList.stream().filter(f -> f.getDataItemName().contains("lzdc_sys_")).sorted(Comparator.comparing(MetadataEntityInfoItemPO::getInfoItemOrder)).collect(Collectors.toList());
      List<MetadataEntityInfoItemPO> unSystemFields = (List<MetadataEntityInfoItemPO>)infoItemPOList.stream().filter(f -> !f.getDataItemName().contains("lzdc_sys_")).sorted(Comparator.comparing(MetadataEntityInfoItemPO::getInfoItemOrder)).collect(Collectors.toList());
      infoItemPOList = unSystemFields;
      infoItemPOList.addAll(systemFields);
    } 
    if (infoItemPOList != null && !infoItemPOList.isEmpty()) {
      List<Long> dataItemIds = new ArrayList<>();
      for (int j = 0; j < infoItemPOList.size(); j++)
        dataItemIds.add(((MetadataEntityInfoItemPO)infoItemPOList.get(j)).getDataItemId()); 
      if (!dataItemIds.isEmpty()) {
        List<MetadataEntityDataItemVO> dataItemVOList = (List<MetadataEntityDataItemVO>)this.dataStandardClient.getMetadataEntityDataItemByIds(dataItemIds, platCode, tokenId).getObj();
        if (dataItemVOList != null && !dataItemVOList.isEmpty()) {
          int order = 0;
          for (int i = 0; i < infoItemPOList.size(); i++) {
            MetadataEntityInfoItemPO infoItemPO = infoItemPOList.get(i);
            if (!isWithSysField.booleanValue()) {
              if (SysFieldHelper.getBaseSysFieldName(BaseSysFieldEnum.LAST_MODIFY_TIME).equalsIgnoreCase(infoItemPO.getDataItemName()) || 
                SysFieldHelper.getBaseSysFieldName(BaseSysFieldEnum.START_TIME).equalsIgnoreCase(infoItemPO.getDataItemName()) || 
                SysFieldHelper.getBaseSysFieldName(BaseSysFieldEnum.USER_NAME).equalsIgnoreCase(infoItemPO.getDataItemName()) || 
                SysFieldHelper.getBaseSysFieldName(BaseSysFieldEnum.SYNC_STATUS).equalsIgnoreCase(infoItemPO.getDataItemName()))
                continue; 
              if (SysFieldHelper.getBaseSysFieldName(BaseSysFieldEnum.INTERFACE_ID).equalsIgnoreCase(infoItemPO.getDataItemName()) || 
                SysFieldHelper.getBaseSysField(BaseSysFieldEnum.DBID).getFieldName().equalsIgnoreCase(infoItemPO.getDataItemName()) || 
                SysFieldHelper.getBaseSysFieldName(BaseSysFieldEnum.IS_DELETE).equalsIgnoreCase(infoItemPO.getDataItemName()) || 
                SysFieldHelper.getBaseSysFieldName(BaseSysFieldEnum.INTERFACE_USER_ID).equalsIgnoreCase(infoItemPO.getDataItemName()))
                continue; 
            } 
            if (!DCConst.FALSE.equals(infoItemPO.getShowInEdit())) {
              ExcelFieldConfigDTO cell = new ExcelFieldConfigDTO();
              cell.setBeginRowIndex(Integer.valueOf(1));
              cell.setEndRowIndex(Integer.valueOf(10000));
              if (SysFieldHelper.getSysFieldCnNameMap().containsKey(infoItemPO.getInfoItemName())) {
                cell.setCellName((String)SysFieldHelper.getSysFieldCnNameMap().get(infoItemPO.getInfoItemName()));
              } else {
                cell.setCellName(infoItemPO.getInfoItemName());
              } 
              cell.setCellIndex(Integer.valueOf(order));
              cell.setControllerType(ECControllerTypeMode.Text);
              cell.setAllowNull(Boolean.valueOf(DCConst.FALSE.equals(infoItemPO.getIsPrimaryKey())));
              for (MetadataEntityDataItemVO item : dataItemVOList) {
                if (infoItemPO.getDataItemId().equals(item.getDataItemId())) {
                  cell.setDataType(item.getDataType());
                  break;
                } 
              } 
              order++;
              if (infoItemPO.getDataRange() != null) {
                MetadataCommonCodeItemQueryDTO commonCodeItemQueryDTO = new MetadataCommonCodeItemQueryDTO();
                commonCodeItemQueryDTO.setCodeTableId(infoItemPO.getDataRange());
                commonCodeItemQueryDTO.setPageIndex(Integer.valueOf(-1));
                List<MetadataCommonCodeItemVO> commonCodeItemVOS = (List<MetadataCommonCodeItemVO>)this.dataStandardClient.getCommonCodeItemsByCodeTableId(commonCodeItemQueryDTO, platCode, tokenId).getObj();
                List<String> dataRange = new ArrayList<>();
                if (commonCodeItemVOS != null && !commonCodeItemVOS.isEmpty())
                  for (int k = 0; k < commonCodeItemVOS.size(); k++)
                    dataRange.add(((MetadataCommonCodeItemVO)commonCodeItemVOS.get(k)).getCodeName());  
                if (!dataRange.isEmpty()) {
                  cell.setDropDownList(dataRange);
                  cell.setControllerType(ECControllerTypeMode.DropDownList);
                } 
              } 
              excelCellList.add(cell);
            } 
            continue;
          } 
        } 
      } 
    } 
    return excelCellList;
  }
  
  private ResultEntity checkEntityAndField(List<ExcelSheetPO> excelSheetPOS, String platCode, String tokenId, Integer isRes) {
    if (excelSheetPOS == null || excelSheetPOS.isEmpty())
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_SET_TEMPLATE_CONFIG_WARN.getCode()), StatusCodeEnum.DATA_RESOURCE_EXCEL_SET_TEMPLATE_CONFIG_WARN.getMessage()); 
    StringBuilder errorStr = null;
    for (int i = 0; i < excelSheetPOS.size(); i++) {
      ExcelSheetPO sheet = excelSheetPOS.get(i);
      DataSourceVO dataSourceVO = null;
      if (sheet.getDatasourceId() != null)
        dataSourceVO = (DataSourceVO)this.dataStandardClient.getDataSourceInfoDoNotDecryptById(sheet.getDatasourceId(), platCode, tokenId).getObj(); 
      ResultEntity<MetadataEntityPO> validateEntityRet = validateEntity(sheet, platCode, isRes, tokenId);
      if (!validateEntityRet.getCode().equals(Integer.valueOf(0)))
        return validateEntityRet; 
      ResultEntity<MetadataDirectoryPO> validateDirectoryRet = validateDirectory(sheet, isRes, tokenId);
      if (!validateDirectoryRet.getCode().equals(Integer.valueOf(0)))
        return validateDirectoryRet; 
      if (dataSourceVO == null)
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_TEMPLATE_DB_IS_USE.getCode()), "请检查数据表【" + ((MetadataEntityPO)validateEntityRet.getObj()).getEntityName() + "】的数据库【" + sheet.getEntityTableName() + "】是否有效"); 
      DataSourceDTO dataSourceDTO = new DataSourceDTO();
      BeanUtils.copyProperties(dataSourceVO, dataSourceDTO);
      ResultEntity<DataStructProvider> getDataBaseProviderRet = DataStructProvider.getDataBaseProvider(dataSourceDTO);
      if (!getDataBaseProviderRet.getCode().equals(Integer.valueOf(0)))
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_CANNOT_OPEN_DB.getCode()), "无法打开请求的数据库【" + (dataSourceDTO.getType().equals("dm") ? dataSourceDTO.getDbSchema() : dataSourceDTO.getDbName()) + "】"); 
      DataStructProvider dataStructProvider = (DataStructProvider)getDataBaseProviderRet.getObj();
      if (!dataStructProvider.isExistsTable(sheet.getEntityTableName()).booleanValue()) {
        String msg = "表【" + sheet.getEntityTableName() + "】在数据库【" + (dataSourceDTO.getType().equals("dm") ? dataSourceDTO.getDbSchema() : dataSourceDTO.getDbName()) + "】中不存在，请确保数据表存在";
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_DB_NOT_EXIST_TABLE.getCode()), msg);
      } 
      List<MetadataEntityInfoItemPO> metadataEntityItemInfoVOList = MetadataManager.getEntityInfoItemsByEntityId(sheet.getEntityId(), isRes, sheet.getPlatCode(), tokenId);
      if (metadataEntityItemInfoVOList == null && metadataEntityItemInfoVOList.isEmpty())
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_ENTITY_DATA_ITEM_NOT_EXIST_WARN.getCode()), StatusCodeEnum.DATA_RESOURCE_EXCEL_ENTITY_DATA_ITEM_NOT_EXIST_WARN.getMessage()); 
      boolean isHavePk = false;
      List<Long> dataItemIds = new ArrayList<>();
      List<String> sameNames = new ArrayList<>();
      for (int j = 0; j < metadataEntityItemInfoVOList.size(); j++) {
        if (!isBaseSysFieldName(((MetadataEntityInfoItemPO)metadataEntityItemInfoVOList.get(j)).getDataItemName())) {
          if (((MetadataEntityInfoItemPO)metadataEntityItemInfoVOList.get(j)).getDataItemId() != null)
            dataItemIds.add(((MetadataEntityInfoItemPO)metadataEntityItemInfoVOList.get(j)).getDataItemId()); 
          if (!DCConst.TRUE.equals(((MetadataEntityInfoItemPO)metadataEntityItemInfoVOList.get(j)).getInfoItemStatus()))
            if (errorStr == null) {
              errorStr = new StringBuilder();
              errorStr.append("数据表【" + sheet.getEntityTableName() + "】中的字段【");
              errorStr.append(((MetadataEntityInfoItemPO)metadataEntityItemInfoVOList.get(j)).getDataItemName());
            } else {
              errorStr.append("、" + ((MetadataEntityInfoItemPO)metadataEntityItemInfoVOList.get(j)).getDataItemName());
            }  
          if (((MetadataEntityInfoItemPO)metadataEntityItemInfoVOList.get(j)).getIsPrimaryKey().equals(DCConst.TRUE))
            isHavePk = true; 
          MetadataEntityInfoItemPO curItem = metadataEntityItemInfoVOList.get(j);
          Boolean isExistSameName = Boolean.valueOf((metadataEntityItemInfoVOList.stream().filter(item -> (item.getInfoItemName().equalsIgnoreCase(curItem.getInfoItemName()) && !item.getInfoItemId().equals(curItem.getInfoItemId()))).count() > 0L));
          if (isExistSameName.booleanValue() && !sameNames.contains(curItem.getInfoItemName()))
            sameNames.add(curItem.getInfoItemName()); 
        } 
      } 
      ResultEntity ret = handErrorRet(isHavePk, validateEntityRet, sameNames, dataItemIds, platCode, tokenId);
      if (ret != null)
        return ret; 
      if (errorStr != null) {
        errorStr.append("】未同步");
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_ENTITY_ITEM_NOT_SYNC_WARN.getCode()), errorStr.toString());
      } 
    } 
    return ResultEntity.successMessage(Boolean.valueOf(true));
  }
  
  private ResultEntity handErrorRet(boolean isHavePk, ResultEntity<MetadataEntityPO> validateEntityRet, List<String> sameNames, List<Long> dataItemIds, String platCode, String tokenId) {
    List<MetadataEntityDataItemVO> dataItemVOS = null;
    if (!isHavePk)
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_NO_PRIMARY_KEY_CANNOT_SET_EXCEL_TEMPLATE.getCode()), "数据表【" + ((MetadataEntityPO)validateEntityRet.getObj()).getEntityName() + "】中没有主键"); 
    if (!sameNames.isEmpty())
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXIST_INFO_ITEM_SAME_NAME_FAILED.getCode()), "数据表【" + ((MetadataEntityPO)validateEntityRet.getObj()).getEntityName() + "】存在重复字段名称【" + String.join(",", (Iterable)sameNames) + "】"); 
    if (!dataItemIds.isEmpty())
      dataItemVOS = (List<MetadataEntityDataItemVO>)this.dataStandardClient.getMetadataEntityDataItemByIds(dataItemIds, platCode, tokenId).getObj(); 
    if (dataItemVOS == null || dataItemVOS.isEmpty())
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_ENTITY_DATA_ITEM_NOT_EXIST_WARN.getCode()), StatusCodeEnum.DATA_RESOURCE_EXCEL_ENTITY_DATA_ITEM_NOT_EXIST_WARN.getMessage()); 
    return null;
  }
  
  private boolean isBaseSysFieldName(String dataItemName) {
    if (SysFieldHelper.getBaseSysFieldName(BaseSysFieldEnum.DBID).equalsIgnoreCase(dataItemName) || SysFieldHelper.getBaseSysFieldName(BaseSysFieldEnum.SYNC_STATUS).equalsIgnoreCase(dataItemName) || SysFieldHelper.getBaseSysFieldName(BaseSysFieldEnum.LAST_MODIFY_TIME).equalsIgnoreCase(dataItemName) || SysFieldHelper.getBaseSysFieldName(BaseSysFieldEnum.START_TIME).equalsIgnoreCase(dataItemName))
      return true; 
    if (SysFieldHelper.getBaseSysFieldName(BaseSysFieldEnum.INTERFACE_ID).equalsIgnoreCase(dataItemName) || SysFieldHelper.getBaseSysFieldName(BaseSysFieldEnum.USER_NAME).equalsIgnoreCase(dataItemName) || SysFieldHelper.getBaseSysFieldName(BaseSysFieldEnum.IS_DELETE).equalsIgnoreCase(dataItemName))
      return true; 
    if (SysFieldHelper.getBaseSysFieldName(BaseSysFieldEnum.INTERFACE_USER_ID).equalsIgnoreCase(dataItemName))
      return true; 
    return false;
  }
  
  private ResultEntity<MetadataEntityPO> validateEntity(ExcelSheetPO sheet, String platCode, Integer dataResourceCategory, String tokenId) {
    ResAndDataEntityDTO resAndDataEntityDTO = MetadataManager.selectEntityByEntityId(sheet.getEntityId(), dataResourceCategory, sheet.getPlatCode(), tokenId);
    MetadataEntityPO metadataEntity = new MetadataEntityPO();
    BeanUtils.copyProperties(resAndDataEntityDTO, metadataEntity);
    if (metadataEntity == null)
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_TEMPLATE_CHECK_TABLE_NOT_EXIST_WARN.getCode()), "模板选择的数据表【" + sheet.getEntityTableName() + "】已被删除，请重新编辑模板"); 
    if (StringUtils.isEmpty(sheet.getEntityTableName()) || sheet.getDatasourceId() == null)
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_TEMPLATE_NO_DB_OR_TABLE.getCode()), "请检查数据表【" + metadataEntity.getEntityName() + "】是否配置了库或表"); 
    sheet.setDirectoryId(metadataEntity.getDirectoryId());
    sheet.setEntityTableName(metadataEntity.getEntityTableName());
    sheet.setDatasourceId(metadataEntity.getDataSourceId());
    ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).updateEntity(sheet);
    return ResultEntity.successMessage(metadataEntity);
  }
  
  private ResultEntity<MetadataDirectoryPO> validateDirectory(ExcelSheetPO sheet, Integer dataResourceCategory, String tokenId) {
    MetadataDirectoryPO metadataDirectoryPO = null;
    if (sheet.getDirectoryId() != null) {
      metadataDirectoryPO = new MetadataDirectoryPO();
      ResAndDataDirectoryDTO resAndDataDirectoryDTO = MetadataManager.selectDirectoryByDirectoryId(sheet.getDirectoryId(), sheet.getPlatCode(), dataResourceCategory, tokenId);
      BeanUtils.copyProperties(resAndDataDirectoryDTO, metadataDirectoryPO);
    } 
    if (metadataDirectoryPO == null)
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_EXCEL_TEMPLATE_CHECK_TABLE_NOT_EXIST_WARN.getCode()), "模板选择的数据表【" + sheet.getEntityTableName() + "】已被删除，请重新编辑模板"); 
    return ResultEntity.successMessage(metadataDirectoryPO);
  }
  
  private boolean deleteInfoByExcelTemplateId(ExcelTemplatePO excelTemplatePO, String platCode, String tokenId) {
    if (excelTemplatePO != null) {
      ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).delEntityById(excelTemplatePO.getTemplateId(), ExcelTemplatePO.class);
      ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).delExcelSheetsByTemplateId(excelTemplatePO.getTemplateId());
      ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(platCode, ICollectionToolDao.class)).delExcelDetailsByTemplateId(excelTemplatePO.getTemplateId());
      String msg = "删除模板【" + excelTemplatePO.getTemplateName() + "】以及相关采集配置和采集详情信息";
      logSystemInfo(msg, platCode, tokenId);
    } 
    return true;
  }
  
  private void logErrorInfo(String stackInfo, String msg, String platCode, String tokenId) {
    CommonLogDTO logDTO = new CommonLogDTO();
    logDTO.setPlatCode(platCode);
    logDTO.setTokenId(tokenId);
    logDTO.setStackInformation(stackInfo);
    logDTO.setLoggerInformation(msg);
    logDTO.setLogLevel(FrameConst.Log.LOG_LEVEL_ERROR);
    logDTO.setLogType(0);
    logDTO.setModule_code(HeaderInterceptor.getModuleCode());
    RabbitMQUtil.publish("DC.Standard.log", logDTO);
  }
  
  private void logSystemInfo(String msg, String platCode, String tokenId) {
    CommonLogDTO logDTO = new CommonLogDTO();
    logDTO.setPlatCode(platCode);
    logDTO.setTokenId(tokenId);
    logDTO.setLoggerInformation(msg);
    logDTO.setLogLevel(FrameConst.Log.LOG_LEVEL_SYSTEM);
    logDTO.setLogType(0);
    logDTO.setModule_code(HeaderInterceptor.getModuleCode());
    RabbitMQUtil.publish("DC.Standard.log", logDTO);
  }
}
